;====================================================================
;                                                                   =
;                     Covert Operation v2.4                         =
;                                                                   =
;   Written By: Morgan Davies                                       =
;   E-mail:     Morgazum85@Juno.com                                 =
;               morgan@ticalc.org                                   =
;   Date:       May 10, 2003                                        =
;   Size:       1275 bytes                                          =
;   Idea From:  Tom Schreurs                                        =
;   E-mail:     magicnba@hotmail.com                                =
;                                                                   =
;   This is a memory screen simulation program for the TI-86        =
;written in ASM for the whole effect. This program was created to   =
;show the capabilites a routine (Menu 86 v1.4) I created earlier    =
;this year.                                                         =
;   As well as showing the potentials of Menu 86 v1.4 this program  =
;simulates every aspect of the 86 memory menu. Except the ability of=
;"fake clearing the Rom" of your calc. Instead of displaying        =
;"Memory cleared" "Defaults Set," it displays an error message.     =
;                                                                   =
;***NOTE***                                                         =
;   This is not a fake memory clearing program!                     =
;                                                                   =
;====================================================================

#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

.plugin lite86;                     ;the ultimate compression rutine, saved 335 bytes

_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String1                     ;print string

String1:    .db "Covert Operation v2.4",0    ;shell header

#include "Menu86.asm"

Start:
    call _flushallmenus             ;clears all key codes
    call _runindicoff               ;turn off run indicator
    call _clrScrn                   ;clears the screen
    ld hl,String2                   ;string to print
    call Text3                      ;goes to Text3
    call _cursorOn                  ;turns on blinking cursor
GetLoop1:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Exit                       ;if Exit jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,RAMMENU                    ;if F1 relative jump to RAMMENU
    cp K_F2                         ;compares a with F2
    jr z,DELETMENU1                 ;if F2 relative jump to DELETMENU1
    cp K_F3                         ;compares a with F3
    jp z,RESETMENU                  ;if F3 jump to RESETMENU
    cp K_F4                         ;compares a with F4
    jp z,TOLMENU                    ;if F4 jump to TOLMENU
    cp K_F5                         ;compares a with F5
    jp z,ClrEntMENU                 ;if F5 jump to ClrEntMENU
    jr GetLoop1                     ;relative jumo to GetLoop1

RAMMENU:
    call _homeup                    ;load hl with coords (0,0)
    call _cursorOff                 ;turns off blinking cursor
    ld hl,String8                   ;string to print
    call _puts                      ;print string
    jr GetLoop1                     ;relative jump to GetLoop1

DELETMENU1:
    call _clrScrn                   ;clears the screen
    call _homeup                    ;load hl with coords (0,0)
    call _cursorOff                 ;turns off blinking cursor
    ld hl,String3                   ;string to print
    call Text4                      ;goes to Text4
    ld hl,String9                   ;string to print
    call _puts                      ;print string
GetLoop2:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jr z,Start                      ;if Exit jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,ALL                        ;if F1 relative jump to ALL
    cp K_F2                         ;compares a with F2
    jr z,REAL                       ;if F2 relative jump to REAL
    cp K_F3                         ;compares a with F3
    jr z,CPLX                       ;if F3 relative jump to CPLX
    cp K_F4                         ;compares a with F4
    jr z,LIST                       ;if F4 relative jump to LIST
    cp K_F5                         ;compares a with F5
    jr z,VECTR                      ;if F5 jump to VECTR
    cp K_MORE                       ;compares a with MORE
    jr z,DELETMENU2                 ;if MORE relative jump to DELETMENU2
    jr GetLoop2                     ;relative jump to GetLoop2

DELETMENU2:
    ld hl,String4                   ;string to print
    call Text4                      ;goes to Text4
GetLoop3:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Start                      ;if Exit jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,MATRX                      ;if F1 relative jump to MATRX
    cp K_F2                         ;compares a with F2
    jr z,STRNG                      ;if F2 relative jump to STRNG
    cp K_F3                         ;compares a with F3
    jr z,EQU                        ;if F3 relative jump to EQU
    cp K_F4                         ;compares a with F4
    jr z,CONS                       ;if F4 relative jump to CONS
    cp K_F5                         ;compares a with F5
    jr z,PRGM                       ;if F5 jump to PRGM
    cp K_MORE                       ;compares a with MORE
    jr z,DELETMENU3                 ;if MORE relative jump to DELETMENU3
    jr GetLoop3                     ;relative jump to Get Loop3

DELETMENU3:
    call _clrScrn                   ;clears the screen
    ld hl,String5                   ;string to print
    call Text3                      ;goes to Text3
    ld hl,String9                   ;string to print
    call _puts                      ;print string
GetLoop4:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Start                      ;if Exit jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,GDB                        ;if F1 relative jump to GDB
    cp K_F2                         ;compares a with F2
    jr z,PIC                        ;if F2 relative jump to PIC
    cp K_MORE                       ;compares a with MORE
    jp z,DELETMENU1                 ;if MORE jump to DELETMENU1
    jr GetLoop4                     ;relative jump to GetLoop4

ALL:
    call Text1                      ;goes to Text1
    ld hl,String11                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

REAL:
    call Text1                      ;goes to Text1
    ld hl,String12                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

CPLX:
    call Text1                      ;goes to Text1
    ld hl,String13                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

LIST:
    call Text1                      ;goes to Text1
    ld hl,String14                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

VECTR:
    call Text1                      ;goes to Text1
    ld hl,String15                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

MATRX:
    call Text1                      ;goes to Text1
    ld hl,String16                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

STRNG:
    call Text1                      ;goes to Text1
    ld hl,String17                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

EQU:
    call Text1                      ;goes to Text1
    ld hl,String18                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

CONS:
    call Text1                      ;goes to Text1
    ld hl,String19                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

PRGM:
    call Text1                      ;goes to Text1
    ld hl,String20                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

GDB:
    call Text1                      ;goes to Text1
    ld hl,String21                  ;string to print
    jr DisplayText                  ;relative jump to DisplayText

PIC:
    call Text1                      ;goes to Text1
    ld hl,String22                  ;string to print
DisplayText:
    call _puts                      ;print string
GetLoop5:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Start                      ;if Exit jump to Exit
    jr GetLoop5                     ;relative jump to GetLoop

RESETMENU:
    call _clrScrn                   ;clears the screen
    ld hl,$ff00                     ;loads coordinates into hl
    ld b,32                         ;# of times to loop and display hl
    call DrawLineHorizontal         ;draws bottom line
    ld hl,$ff00                     ;loads coordinates into hl
    ld b,8                          ;# of times to loop and display c
    ld c,%11100000                  ;what to display @ c
    call DrawLineVertical           ;draws left side line
    ld hl,$ff0f                     ;looads coordinates into hl
    ld b,8                          ;# of times to loop and display c
    ld c,%00000110                  ;what to display @ c
    call DrawLineVertical           ;draws right side line
    ld hl,$ff0f                     ;loads coordinates into hl
    ld (hl),%11111110               ;what to display @ hl
    ld hl,$ff1f                     ;loads coordinates into hl
    ld (hl),%11111110               ;what to display @ hl
    set 3,(iy+5)                    ;inverts text to white text on black
    ld hl,String2                   ;string to print
    ld bc,256*50+3                  ;column 4, row 51
    ld (_penCol),bc                 ;loads (_penCol) with bc
    call _vputs                     ;print it and return
    res 3,(iy+5)                    ;reverts text back to black on white
    ld hl,String6                   ;string to print
    call Text3                      ;goes to Text3
    call _cursorOn                  ;turns on blinking cursor
GetLoop6:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Start                      ;if Exit jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,RESETALL                   ;if F1 relative jump to RESETALL
    cp K_F2                         ;compares a with F2
    jr z,RESETALL                   ;if F2 relative jump to RESETALL
    cp K_F3                         ;compares a with F3
    jr z,RESETDFLTS                 ;if F3 relative jump to RESETDFLTS
    jr GetLoop6                     ;relative jump to GetLoop6

RESETALL:
    call Text2                      ;goes to Text2
GetLoop7:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Start                      ;if Exit jump to Exit
    cp K_F5                         ;compares a with F5
    jp z,Start                      ;if F5 jump to Exit
    cp K_F4                         ;compares a with F4
    jr z,YES1                       ;if F4 relative jump to YES1
    jr GetLoop7                     ;relative jump to GetLoop7

RESETDFLTS:
    call Text2                      ;goes to Text2
GetLoop9:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jp z,Start                      ;if Exit jump to Exit
    cp K_F5                         ;compares a with F5
    jp z,Start                      ;if F5 jump to Exit
    cp K_F4                         ;compares a with F4
    jr z,YES2                       ;if F4 relative jump to YES2
    jr GetLoop9                     ;relative jump to GetLoop9

YES1:
    call _clrScrn                   ;clears the screen
    ld hl,String26                  ;string to print
    ld bc,256*58+106                ;column 107, row 59
    call SubText3                   ;goes to SubText3
    call _homeup                    ;load hl with coords (0,0)
    ld hl,String25                  ;string to print
    jr EndText                      ;relative jump to EndText

YES2:
    call _clrScrn                   ;clears the screen
    ld hl,$0503                     ;loads coordinates into hl
    ld (_curRow),hl                 ;loads (_curRow),hl
    ld hl,String27                  ;string to print
EndText:
    call _puts                      ;print string
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;return to Start

TOLMENU:
    call _clrScrn                   ;clears the screen
    call _homeup                    ;load hl with coords (0,0)
    ld hl,String28                  ;string to print
    call _puts                      ;print string
    ld hl,$0501                     ;loads coordinates into hl
    ld (_curRow),hl                 ;loads (_curRow),hl
    call _cursorOn                  ;turns on blinking cursor
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;returns to Start

ClrEntMENU:
    call _homeup                    ;load hl with coords (0,0)
    call _cursorOn                  ;turns on blinking cursor
Another:
    ld hl,String29                  ;string to print
    call _puts                      ;print string
GetLoop10:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compare a with Exit
    jr z,Exit                       ;if Exit jump to Exit
    cp K_ENTER                      ;compares a with ENTER
    jp z,Start                      ;if ENTER relative jump to Exit
    cp K_F5                         ;compares a with F5
    jr z,Another                    ;if F5 relative jump to Another
    cp K_F1                         ;compares a with F1
    jp z,RAMMENU                    ;if F1 jump to RAMMENU
    cp K_F2                         ;compares a with F2
    jp z,DELETMENU1                 ;if F2 jump to DELETMENU1
    cp K_F3                         ;compares a with F3
    jp z,RESETMENU                  ;if F3 jump to RESETMENU
    cp K_F4                         ;compares a with F4
    jr z,TOLMENU                    ;if F4 relative jump to TOLMENU
    jr GetLoop10                    ;relative jump to GetLoop10

Exit:
    call _homeup                    ;load hl with coords (0,0)
    call _clrScrn                   ;clears the screen
    call _cursorOff                 ;turns off blinking cursor
    ret                             ;exit the program

DrawLineVertical:
    ld de,$10                       ;loads de with $10 ??? Don't know???
LineLoop:
    ld a,(hl)                       ;loads a with contents of video mem @ hl
    or c                            ;turns on the pixels specified by c w/o affecting others
    ld (hl),a                       ;loads a back into video mem
    add hl,de                       ;moves to next line
    djnz LineLoop                   ;repeat until b=0
    ret                             ;return

DrawLineHorizontal:
    ld (hl),%11111111               ;loads video mem @ hl w/ line
    inc hl                          ;moves one to the right
    djnz DrawLineHorizontal         ;repeat until line is drawn
    ret                             ;return

Text1:
    call _clrScrn                   ;clears the screen
    ld hl,String10                  ;string to print
    call Text3                      ;goes to Text3
    ld hl,String9                   ;string to print
    call _puts                      ;print string
    ld hl,$0001                     ;loads coordinates into hl
    ld (_curRow),hl                 ;loads (_curRow) with hl
    ld hl,String23                  ;string to print
    call _puts                      ;print string
    ld hl,$0600                     ;loads coordinates into hl
    ld (_curRow),hl                 ;loads (_curRow) with hl
    ret                             ;return to call

Text2:
    call _cursorOff                 ;turns off blinking cursor
    call _clrScrn                   ;clears the screen
    ld hl,String7                   ;string to print
    ld bc,256*58+83                 ;column 84, row 59
    call SubText3                   ;goes to SubText3
    ld hl,$0403                     ;loads coordinates into hl
    ld (_curRow),hl                 ;loads (_curRow) with hl
    ld hl,String24                  ;string to print
    call _puts                      ;print string
    ret                             ;return to call

Text3:
    ld bc,256*58+3                  ;column 4, row 59
SubText3:
    ld (_penCol),bc                 ;loads coords into _penCol
    call _vputs                     ;print it and return
    ld hl,Sprite7                   ;loads sprite
    call DrawMenu                   ;goes to DrawMenu
    call _homeup                    ;load hl with coords (0,0)
    ret                             ;return to call

Text4:
    ld bc,256*58+3                  ;column 4, row 59
    ld (_penCol),bc                 ;loads coords into _penCol
    call _vputs                     ;print it and return
    ld hl,Sprite8                   ;loads sprite
    call DrawMenu                   ;goes to DrawMenu
    call _homeup                    ;load hl with coords (0,0)
    ret                             ;return to call

String2:    .db "    RAM        DELET     RESET         TOL        ClrEnt",0
String3:    .db "     ALL           REAL         CPLX          LIST        VECTR",0
String4:    .db "MATRX   STRNG       EQU          CONS       PRGM ",0
String5:    .db "    GDB              PIC",0
String6:    .db "     ALL           MEM       DFLTS",0
String7:    .db "YES               NO",0
String8:    .db "MEM FREE 66833       "
            .db "REAL   244 CPLX     0"
            .db "LIST  2186 VECT     0"
            .db "MATR   809 STRN   180"
            .db "EQU      0 CONS     0"
            .db "PRGM 20640 GDB    271"
            .db "PIC   7144",0
String9:    .db "DELETE",0
String10:   .db "PAGE",31,"    PAGE",30,"",0
String11:   .db ":ALL",0
String12:   .db ":REAL",0
String13:   .db ":CPLX",0
String14:   .db ":LIST",0
String15:   .db ":VECTR",0
String16:   .db ":MATRX",0
String17:   .db ":STRNG",0
String18:   .db ":EQU",0
String19:   .db ":CONS",0
String20:   .db ":PRGM",0
String21:   .db ":GDB",0
String22:   .db ":PIC",0
String23:   .db "",5,"Aim       1282 PRGM "
            .db " B          809 MATRX"
            .db " CovertOp  1596 PRGM "
            .db " Newton    1002 PRGM "
            .db " QuadForm   142 PRGM "
            .db " yStat       13 LIST",0
String24:   .db "Are you sure?",0
String25:   .db "ERROR 69 FAKE CLEAR",0
String26:   .db "QUIT",0
String27:   .db "Defaults set",0
String28:   .db "TOLERANCE            "
            .db " tol=1",27,26,"5            "
            .db " ",191,"=.001",0
String29:   .db "ClrEnt",0

.end
END