;====================================================================
;                                                                   =
;                         Menu 86 v1.4                              =
;                                                                   =
;   Written By: Morgan Davies                                       =
;   E-mail:     Morgazum85@Juno.com                                 =
;   Date:       November 18, 2002                                   =
;   Size:       159 bytes                                           =
;                                                                   =
;   If you wish to port programs directly from TI-86 Basic, you     =
;will need a menu drawer. The unique thing about this menu drawer   =
;is that you can insert text before the routine is called, and the  =
;text will not be erased. Using BMP2ASM would overight the text.    =
;A short program explaning the use of this Routine is listed in     =
;the asm file. Give credit if you feel like it. If you have         =
;questions contact me at the E-mail above.                          =
;                                                                   =
;====================================================================

MenuRoutine1:
    ld hl,Sprite7                   ;loads sprite
    jr DrawMenu                     ;relative jump to DrawMenu
MenuRoutine2:    
    ld hl,Sprite8                   ;loads sprite
DrawMenu:
    ld de,$070F                     ;loads coordinates to de
    call MenuLoop                   ;goes to MenuLoop
    ld hl,Sprite6                   ;loads sprite
    call MenuLoop                   ;goes to MenuLoop
    ld hl,Sprite5                   ;loads sprite
    call MenuLoop                   ;goes to MenuLoop
    ld hl,Sprite4                   ;loads sprite
    call MenuLoop                   ;goes to MenuLoop
    ld hl,Sprite3                   ;loads sprite
    call MenuLoop                   ;goes to MenuLoop
    ld hl,Sprite2                   ;loads sprite
    call GridPutSprite              ;displays sprite
    ret                             ;return to call
MenuLoop:
    call GridPutSprite              ;displays sprite
    ld hl,Sprite1                   ;loads sprite
    call GridPutSprite              ;displays sprite
    ld hl,Sprite1                   ;loads sprite
    call GridPutSprite              ;displays sprite
    ret                             ;return to call

GridPutSprite:
    push de                         ; save position of sprite
    push hl                         ; push hl to stack
    pop ix                          ; ...and pop it into iy
    srl d                           ; de = (128 * y) + x
    rra                             ; carry flag -< msb of a
    and $80                         ; a is either $00 or %80
    or e                            ; add x offset (remember x <= 15
    ld e,a                          ; de = (128 * y) + (x * 8)
    ld hl,$fc00                     ; hl-> video memory
    add hl,de                       ; hl-> video memory + offset
    ld b,8                          ; initialize loop counter
    ld de,16                        ; screen is 16 bytes wide

GPS_Loop:
    ld a,(ix + 0)                   ; get byte from sprite
    ld c,(hl)                       ; load c w/contents of video mem                    |These two lines are
    or c                            ; turn on pixels in sprite w/o turning off others   |Matt Bennett's additions
    ld (hl),a                       ; put byte on screen
    inc ix                          ; move to next byte in sprite
    add hl,de                       ; move to next line on screen
    djnz GPS_Loop                   ; loop until sprite is drawn
    pop de                          ; recall position of last sprite
    dec de                          ; decrease position by 1
    ret                             ; return to call

Sprite1:
    .db %11111111
    .db %11111111
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000
    .db %00000000

Sprite2:
    .db %11111111
    .db %11111111
    .db %11000000
    .db %11000000
    .db %11000000
    .db %11000000
    .db %11000000
    .db %11000000

Sprite3:
    .db %11111111
    .db %11111111
    .db %01100000
    .db %01100000
    .db %01100000
    .db %01100000
    .db %01100000
    .db %01100000

Sprite4:
    .db %11111111
    .db %11111111
    .db %00110000
    .db %00110000
    .db %00110000
    .db %00110000
    .db %00110000
    .db %00110000

Sprite5:
    .db %11111111
    .db %11111111
    .db %00011000
    .db %00011000
    .db %00011000
    .db %00011000
    .db %00011000
    .db %00011000

Sprite6:
    .db %11111111
    .db %11111111
    .db %00001100
    .db %00001100
    .db %00001100
    .db %00001100
    .db %00001100
    .db %00001100

Sprite7:
    .db %11111110
    .db %11111110
    .db %00000110
    .db %00000110
    .db %00000110
    .db %00000110
    .db %00000110
    .db %00000110

Sprite8:
    .db %11111110
    .db %11111110
    .db %00000000
    .db %00000100
    .db %00000110
    .db %00000111
    .db %00000110
    .db %00000100

.end
END